/* 
print.c 
ALICE V 2.0, January 1993
library functions for printing 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* functions contained in this module: 
handle_print
print_file 
print_line
*/ 
 
/* Includefiles */ 
 
# include <ctype.h> 
# include <math.h> 
# include <stdio.h> 
# include <stdlib.h> 
# include <string.h> 
# include <time.h>
 
# include <aes.h> 
# include <tos.h> 
# include <vdi.h> 
 
 
# include "language.h" 
# include "prvdef.h" 
# include "mewidi.h" 
# include "messages.h" 
# include "scancode.h" 
# include "structs.h" 
# include "extdef.h" 
# include "rsc.h" 
 
/* References to global data defined elsewhere  */ 
 
extern  int         ap_id, handle; 
extern  int         bzeich, hzeich, gbl_clip[]; 
extern  WIND_DATA   windows[]; 
extern  int         prgquit, prgexit; 
extern  int         page_length, left_margin, header, lines; 
extern  OBJECT      *dial_print;
extern  int         from_page, to_page, page_number, page_offset; 
extern  char        text[]; 
 
 
 
/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 

/* main routine for print handling  */
 

int   handle_print ()
{
  long        num_lines; 
  int         i, a, b, c, d, e, f, g; 
  int         w_handle, w_index, garbage, item_hit; 
  int         num_pages;
  int         header_save, lines_save;
  int         num_copies;
  TEDINFO     *ted_info; 


  w_handle = top_wind ();
  w_index = get_index_from_handle (w_handle); 
  if (w_index == -1 || !own_top_wind ()) 
  {
    return (FALSE); 
  }
  ted_info = dial_print[PAGELEN].ob_spec.tedinfo; 
  sprintf (text, "%3d", page_length); 
  strcpy (ted_info->te_ptext, text); 
  ted_info = dial_print[LEFTMAR].ob_spec.tedinfo; 
  sprintf (text, "%2d", left_margin); 
  strcpy (ted_info->te_ptext, text); 
  ted_info = dial_print[FROMPAGE].ob_spec.tedinfo; 
  sprintf (text, "%3d", 1); 
  strcpy (ted_info->te_ptext, text); 
  ted_info = dial_print[TOPAGE].ob_spec.tedinfo; 
  sprintf (text, "%3d", 999); 
  strcpy (ted_info->te_ptext, text);
  ted_info = dial_print[PAGEOFFS].ob_spec.tedinfo; 
  sprintf (text, "%3d", 1); 
  strcpy (ted_info->te_ptext, text);
  ted_info = dial_print[NCOPIES].ob_spec.tedinfo; 
  sprintf (text, "%3d", 1); 
  strcpy (ted_info->te_ptext, text);
  header_save = 
    (dial_print[HEADYES].ob_state == SELECTED);
  lines_save  = 
    (dial_print[LINEYES].ob_state == SELECTED);
  garbage = TRUE; 
  while (garbage) /* check for proper printer setup */ 
  {                             /*  1. while start  */ 
    item_hit = handle_dial (dial_print, 0); 
    if (dial_print[HEADYES].ob_state == SELECTED) 
    { 
      header = TRUE;
    } 
    else                        /* radio buttons... */ 
    { 
      header = FALSE;
    } 
    if (dial_print[LINEYES].ob_state == SELECTED) 
    { 
      lines = TRUE;
    } 
    else                        /* radio buttons... */ 
    { 
      lines = FALSE;
    } 
    garbage  = FALSE; 
    ted_info = dial_print[PAGELEN].ob_spec.tedinfo; 
    a = atoi (ted_info->te_ptext); 
    garbage = (a == 0);
    ted_info = 
      dial_print[LEFTMAR].ob_spec.tedinfo; 
    b = atoi (ted_info->te_ptext);
    if (!garbage) garbage = (b == 0);
    ted_info = 
      dial_print[FROMPAGE].ob_spec.tedinfo; 
    c = atoi (ted_info->te_ptext); 
    if (!garbage) garbage = (c == 0);
    ted_info = 
      dial_print[TOPAGE].ob_spec.tedinfo; 
    d = atoi (ted_info->te_ptext); 
    if (!garbage) garbage = (d == 0);
    ted_info = 
      dial_print[PAGEOFFS].ob_spec.tedinfo; 
    e = atoi (ted_info->te_ptext); 
    if (!garbage) garbage = (e == 0);
    if (!garbage) garbage = (d < c);
    if (dial_print[HEADYES].ob_state == SELECTED)
    {
      f = page_length - 2;
    }
    else
    {
      f = page_length;
    }
    num_lines = windows[w_index].doc_length / hzeich; 
    num_pages = (int) ((num_lines - 1 ) / f);
    num_pages++;
    if (!garbage) garbage = (c > num_pages);
    ted_info = 
      dial_print[NCOPIES].ob_spec.tedinfo; 
    g = atoi (ted_info->te_ptext);
    if (!garbage) garbage = (g == 0);
    if (item_hit == STARTPRI || item_hit == OKPRI)
    {
      if (garbage) 
      { 
        put_message (NO_PRINT_SETUP); 
      } 
      else 
      { 
        page_length = a;
        left_margin = b;
        from_page   = c;
        to_page     = d;
        page_offset = e - 1;
        num_copies  = g;
        if (item_hit == STARTPRI)
        {
          refresh_window (w_handle);
          MOUSE_IS_BUSY;
          for (i = 0; i < num_copies; i++)
          { 
            if (!print_file (w_index)) 
            {
              display_pos (w_index);
              return (FALSE);
            }
          }
          display_pos (w_index);
          MOUSE_IS_ARROW; 
        }
      }
    }
    else    /* "cancel" option  */
    { 
      garbage = FALSE;    /* enable exit from loop */ 
                      /* restore previous settings  */
      if (header_save)
      {
        objc_change (dial_print, HEADYES,  
                      0, 0, 0, 0, 0, SELECTED, 0); 
        objc_change (dial_print, HEADNO,  
                      0, 0, 0, 0, 0, NORMAL, 0); 
      }
      else
      {
        objc_change (dial_print, HEADNO,  
                      0, 0, 0, 0, 0, SELECTED, 0); 
        objc_change (dial_print, HEADYES,  
                      0, 0, 0, 0, 0, NORMAL, 0); 
      }
      if (lines_save)
      {
        objc_change (dial_print, LINEYES,  
                      0, 0, 0, 0, 0, SELECTED, 0); 
        objc_change (dial_print, LINENO,  
                      0, 0, 0, 0, 0, NORMAL, 0); 
      }
      else
      {
        objc_change (dial_print, LINENO,  
                      0, 0, 0, 0, 0, SELECTED, 0); 
        objc_change (dial_print, LINEYES,  
                      0, 0, 0, 0, 0, NORMAL, 0); 
      }
    }                               /* 1. if end  */ 
  }                               /* 1. while end */ 
                  display_pos (w_index);
  return (TRUE);
}


 
/* prints a file to the device PRN: (standard printer)       */ 

 
int   print_file (w_index) 
int   w_index;      /* index into global "windows" structure  */ 
{ 
 
  int             i, line_count, lfd_number;
  long            text_line; 
  LINE_DESC       *p, *next; 
  char            header_line[WD_PRINTER_LINE+1];
  char            help_line[WD_PRINTER_LINE+1];
  char            line_number[WD_PRINTER_LINE+1];
  time_t          timer;
  struct  tm      *time_tm;
  int             print_device;
  char            info_string     [MAX_LINE];
  static  char    one_char[2]     = {' ', '\0'}; 
  static  char    us_set[4]       = {ESC, 'R', 0, '\0'};  
                              /* Epson specific escape sequence */

  
  print_device = Fopen (PRINTER, FO_WRITE); /* ensure exclusive   */
                                            /* access to printer  */
  if (print_device == NO_ACCESS_TO_PRINTER)
  {
    put_message (PRINTER_BUSY);     /* might occur in a         */
                                    /* multitasking environment */
    return (FALSE);  
  }
  page_number = 1;
  lfd_number  = page_offset + 1;
  for (i = 0; i < WD_PRINTER_LINE; i++) header_line[i] = ' ';
  sprintf (header_line, "%s  ", windows[w_index].file_name); 
  for (i = (int) strlen (header_line) - 1; i < WD_PRINTER_LINE; i++) 
  {
    header_line[i] = ' '; 
  }

  for (i = 0; i < WD_PRINTER_LINE; i++) help_line[i] = '\0';
  timer = time ((time_t) NULL);
  if (timer != -1) 
  { 
    time_tm   = localtime (&timer);         /* convert time string  */
    strftime (help_line, 17, " %d-%b-%y %H:%M ", time_tm);
    strcpy (header_line + WD_PRINTER_LINE - 20 - 17 - 5, help_line);
                                /* offsets: 20 for the page number  */
                                /*          17 for the time         */
                                /*           5 traing blanks        */
  }
  Fwrite (print_device, 3, us_set);             /* set printer to   */
                                                /* US character set */
 
  line_count  = 0; 
  text_line   = 1;
  for (i = 0; i < left_margin; i++) 
  { 
    help_line[i] = ' ';               /* some blanks as left margin */ 
  }
  help_line[left_margin] = '\0';
  
  for (p = windows[w_index].head; p != NULL; p = next) 
  {                                           /* 1. for start */ 
    next = p->next;
    if (page_number > to_page) continue; 
    if (line_count == 0)
    {
# ifdef english
      sprintf (info_string, " %s Page %d of %ld ", 
               "File is being printed...", 
               lfd_number, 
               min ((long) number_of_pages (w_index),
                    (long) (to_page - from_page + 1)));
# endif
# ifdef german
      sprintf (info_string, " %s Seite %d von %ld ", 
               "Datei wird gedruckt...", 
               lfd_number, 
               min ((long) number_of_pages (w_index),
                    (long) (to_page - from_page + 1)));
# endif
# ifdef french
      sprintf (info_string, " %s Page %d de %ld ", 
               "Fichier est imprim\202...", 
               lfd_number, 
               min ((long) number_of_pages (w_index),
                    (long) (to_page - from_page + 1)));
# endif
      wind_set (windows[w_index].handle, 
                WF_INFO,    
                HIGHW(info_string), 
                LOWW(info_string), 
                0, 0);
    }
    if (line_count == 0 && header)
    {

# ifdef english
      sprintf (header_line + WD_PRINTER_LINE - 20 - 1 - 5, 
              "  %s %d \n",
               "Page", lfd_number);
                                /* offsets: 20 for the page number  */
                                /*           5 traing blanks        */
                                /*           1 to cut of the '\0'   */
# endif
# ifdef german
      sprintf (header_line + WD_PRINTER_LINE - 20 - 1 - 5, 
              "  %s %d \n",
               "Seite", lfd_number);
                                /* offsets: 20 for the page number  */
                                /*           5 traing blanks        */
                                /*           1 to cut of the '\0'   */
# endif
# ifdef french
      sprintf (header_line + WD_PRINTER_LINE - 20 - 1 - 5, 
              "  %s %d \n",
               "Page", lfd_number);
                                /* offsets: 20 for the page number  */
                                /*           5 traing blanks        */
                                /*           1 to cut of the '\0'   */
# endif

      /* print header line(s) */

      if (!print_line (help_line, print_device)) return (FALSE);
      if (!print_line (header_line, print_device)) return (FALSE);
      line_count++;
      if (!print_line (help_line, print_device)) return (FALSE);
      if (!print_line ("\n", print_device)) return (FALSE);
      line_count++;
    }
    if (!print_line (help_line, print_device)) return (FALSE);
    sprintf (line_number, "%5ld  ", text_line);
    if (lines)                          /* with line numbers? */
    {
      if (!print_line (line_number, print_device)) return (FALSE);
      text_line++;
    }
    
    /* print ordinary text  */
    
    if (!print_line (p->line, print_device)) return (FALSE);
    line_count++; 
    
    if (line_count >= page_length) 
    { 
      if (page_number >= from_page && page_number <= to_page)
      {
        one_char[0] = '\f';                         /* new page */
        if (!print_line (one_char, print_device))  return (FALSE);
        lfd_number++;
      } 
      line_count = 0;
      page_number++; 
    } 
  }
  if (line_count != 0)  
  {
    one_char[0] = '\f';
    if (!print_line (one_char, print_device))  /* final form feed  */ 
    { 
      Fclose (print_device);
      return (FALSE);
    } 
  }
  Fclose (print_device);        /* release the printer  */
  return (TRUE);
}                               /* end of function print_file */ 
 


/* function for printing a single line                              */
/* if an error occurs (including interruping the printout) the      */
/* function closes the printing device and returns FALSE.           */
/* Otherwise the function returns TRUE.                             */

int   print_line (line, print_device)   /* prints a single line   */
char  line[];                           /* line to be printed     */
int   print_device;                     /* handle for the device  */
{
  int             i, len, german_letter, letter;
  unsigned char   c;
  int             mousex, mousey, mouse_state, keybd_state;
  static  char    one_char[2]   = {' ', '\0'};
  static  char    us_set[4]     = {ESC, 'R', 0, '\0'};
                                /* Epson specific escape sequence   */
                                /* for US character set             */
  static  char    german_set[4] = {ESC, 'R', 2, '\0'};
                                /* Epson specific escape sequence   */
                                /* for german character set         */
    
        
  if (page_number < from_page || page_number > to_page) return (TRUE);
  evnt_timer (1, 0);
  len = (int) strlen (line);
  for (i = 0; i < len; i++) 
  {           
    /* check for interrupt request by the user  */
    graf_mkstate (&mousex, &mousey, &mouse_state, &keybd_state);
    if ((mouse_state & RIGHT_MOBUTTON) && 
        ((keybd_state & K_RSHIFT) || (keybd_state & K_LSHIFT))) 
        /* right mouse button and any shift key */
    {

# ifdef english
      if (form_alert (1, 
          "[2][ Stop printing ? ][ Yes | No ]") == 1)
# endif
# ifdef german
      if (form_alert (1, 
          "[2][ Ausdruck abbrechen ? ][ Ja | Nein ]") == 1)
# endif
# ifdef french
      if (form_alert (1, 
          "[2][ Interrompre l'impression ? ][ Oui | Non ]") == 1)
# endif

      {
        put_message (PRINT_INTERRUPTED);
        Fwrite (print_device,         /* send interrupt string  */
                strlen (PRT_BREAK),   /* to the printer         */
                PRT_BREAK);
        one_char[0] = '\f';
        Fwrite (print_device, 1, one_char);
        Fclose (print_device);      /* release the printing device  */
        return (FALSE);
      }
      else
      {
        MOUSE_IS_BUSY;
      }
    }
    c = line[i]; 
    german_letter = FALSE; 

    /* the following "if" statement should rather be data     */
    /* driven, i.e. the transformations and escape sequences  */
    /* should be read from an editable printer configuration  */
    /* file. this feature will be implemented in a future     */
    /* version...                                             */

    if (c == 132 || c == 142 || c == 148 || c == 153 || 
        c == 129 || c == 154 || c == 158 || c == 221 ||
        c == 225) 
    {                             /* check for special chars  */ 
      german_letter = TRUE; 
      Fwrite (print_device, 3, german_set); /* german char set  */

      /* transform special chars to a value between 1 and 127   */ 
      
      
      letter = (int) c;
      switch (letter)
      {
        case 132: 
                  c = 123;
                  break;
        case 142: 
                  c = 91;
                  break;
        case 148: 
                  c = 124;
                  break;
        case 153: 
                  c = 92;
                  break;
        case 129: 
                  c = 125;
                  break;
        case 154: 
                  c = 93;
                  break;
        case 158: 
        case 225:           /* thank you, Kurti */ 
                  c = 126;
                  break;
        case 221: 
                  c = 64;
                  break;
        default:
                  break;
      }
    } 
    one_char[0] = c;
    if (Fwrite (print_device, 1, one_char) == EOF)  /* normal text  */
    { 
      put_message (PRINTER_ERROR);
      Fclose (print_device);  /* release the printing device  */
      return (FALSE); 
    } 
    if (german_letter) 
    { 
      Fwrite (print_device, 3, us_set);   /* back to US char set  */
    } 
  }                                     /* 1. for end */
  return (TRUE);
}                                    /* end of function print_line */



 
/* end of file print.c */ 
 
