/* 
prvdef.h 
ALICE V 2.0, January 1993
header for several private definitions 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
 
/* Constants  */ 
 
# define  TRUE    1 
# define  FALSE   0 
 
# define  MAX_LINE    WD_MAX_LINE_LENGTH  
# define  TAB_SIZE    2 
 
# define  ESC   '\033' 
# define  CR    '\015' 
# define  LF    '\012' 
 
# define  PRINTER               "PRN:"  /* default print device */
# define  NO_ACCESS_TO_PRINTER  -36     /* GEMDOS constant  */
 
# define  YEAROFFSET 1980 
 
# define  MSG_BUFFER  8         /* buffer size required by GEM    */ 
# define  BYTE_LENGTH 8 
# define  WORD_LENGTH (sizeof(WORD) * 8) 

 
/* Macros */ 
 
# define  MAXINT(x,y) ( ((x)>(y)) ? (x) : (y) ) 
# define  MININT(x,y) ( ((x)<(y)) ? (x) : (y) ) 
 
# define  BELL            printf ("\007") 
# define  CLS             printf ("\033E") 
# define  SAVE_CURSOR     printf ("\033j") 
# define  RESTORE_CURSOR  printf ("\033k") 
# define  CURSOR_SHOW     printf ("\033e") 
# define  CURSOR_HOME     printf ("\033H") 
# define  CURSOR_RIGHT    printf ("\033C") 
# define  CURSOR_LEFT     printf ("\033D") 
# define  CURSOR_UP       printf ("\033A") 
# define  CURSOR_DOWN     printf ("\033B") 
# define  CLEAR_TO_EOL    printf ("\033K") 
# define  CLEAR_TO_EOP    printf ("\033J") 
# define  REVERSE_VIDEO   printf ("\033p") 
# define  NORMAL_VIDEO    printf ("\033q") 
# define  ERASE_LINE      printf ("\033l") 
 
/* Others */ 

# ifdef english
# define RSC_FILE "ALICE.RSC" 
# endif
# ifdef german
# define RSC_FILE "ALICD.RSC" 
# endif
# ifdef french
# define RSC_FILE "ALICF.RSC" 
# endif
 

# define ALICE_VERSION "2.0 "			/* 4 characters, e.g. "1.42" */
# define ALICE_AUTHOR  "Ralf Kaufmann"

void X_wD_dx (void); void X_wD_dy (void);


/********************************************************/ 
/*                                                      */ 
/*  Typedefs                                            */ 
/*                                                      */ 
/********************************************************/ 
 
 
 
  /****************************************************/ 
  /*                                                  */ 
  /*  Structures for calls to system functions        */ 
  /*                                                  */ 
  /****************************************************/ 
 
typedef struct    /* returned by gemdos function Dfree  */ 
{ 
  long  b_free; 
  long  b_total; 
  long  b_secsiz; 
  long  b_clsiz; 
} OLD_DISKINFO; 
 
 
 
 
 
 
  /****************************************************/ 
  /*                                                  */ 
  /*                Others                            */ 
  /*                                                  */ 
  /****************************************************/ 
 
 
typedef char            CHAR; 
typedef unsigned char   UCHAR; 
typedef char            SHORT; 
typedef unsigned char   USHORT; 
typedef char            BYTE; 
typedef unsigned char   UBYTE; 
typedef int             INT; 
typedef unsigned int    UINT; 
typedef int             WORD; 
typedef unsigned int    UWORD; 
typedef long            LONG; 
typedef unsigned long   ULONG; 
 
 
 
typedef struct  line_desc 
{ 
  char              *line;      /* pointer to text       */ 
  int               len;        /* strlen of mline       */ 
  int               size;       /* (fix) size of array   */ 
  struct  line_desc *prev;      /* previous line         */ 
  struct  line_desc *next;      /* next line             */ 
} LINE_DESC; 
 
 
 
 
/* end of file prvdef.h  */ 
